#include <Stepper.h> // Biblioteca para o Stepper Motor

const int nPassos = 200; // Número de passo a dar em cada "pedido"
Stepper myStepper(nPassos, 12, 11, 10, 9); // Cria o objeto myStepper

const byte btPort = 6; // Porta utilizada pelo botão de abrir e fechar o portão
bool aberto       = false; // Variável que indica que o portão está aberto ou fechado - false -> fechado

const byte limitBt = 4; // Porta utilizada pelo botão de limite - indica que o portão chegou ao fundo
int valueLMB;           // Variável que vai guardar o valor do botão de limite

void setup() {
  Serial.begin(9600);

  myStepper.setSpeed(150); // Velocidade do Stepper Motor

  pinMode(btPort, INPUT); // pinMode dos botões utilizados pelo Stepper Motor
  pinMode(limitBt, INPUT);

  // Inicializar portão //
  valueLMB = digitalRead(limitBt);
  Serial.println(valueLMB);

  if(valueLMB == 0){
    Serial.println("Portão Aberto!!! A fechar...");
    fechaPortaoAutomatico();
  }else{
    Serial.println("Portão Fechado!!! Podemos Continuar...");
  }
}

void loop() {
  // ler botão para abrir e fechar portão
  int valueBtPortao = digitalRead(btPort);
  valueLMB = digitalRead(limitBt);

  if(valueBtPortao == 1){
    if(!aberto){
      Serial.println("A abrir portão...");
      for(int i=0; i<20; i++){
        myStepper.step(nPassos);
      }
      aberto = true;
    } else {
      Serial.println("A fechar portão...");
      for(int i=0; i<20; i++){
        myStepper.step(-nPassos);
      }
      aberto = false;
    }
  }
}

void fechaPortaoAutomatico(){
  do{
    myStepper.step(-10);
    valueLMB = digitalRead(limitBt);    
    Serial.println(valueLMB);
  } while(valueLMB != 1);
}
